## sdformat 1.4.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

if(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
  CMAKE_POLICY(SET CMP0004 NEW)
endif(COMMAND CMAKE_POLICY)
enable_testing()

# with -fPIC
if(UNIX AND NOT WIN32)
  set (CMAKE_INSTALL_PREFIX "/usr" CACHE STRING "Install Prefix")
 find_program(CMAKE_UNAME uname /bin /usr/bin /usr/local/bin )
 if(CMAKE_UNAME)
   exec_program(uname ARGS -m OUTPUT_VARIABLE CMAKE_SYSTEM_PROCESSOR)
   set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR} CACHE INTERNAL
     "processor type (i386 and x86_64)")
   if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
     ADD_DEFINITIONS(-fPIC)
   endif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
 endif(CMAKE_UNAME)
endif()

project (SDFormat)
string (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

set (SDF_MAJOR_VERSION 1)
set (SDF_MINOR_VERSION 4)
set (SDF_PATCH_VERSION 11)

set (SDF_VERSION ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION})
set (SDF_VERSION_FULL ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION}.${SDF_PATCH_VERSION})

message (STATUS "${PROJECT_NAME} version ${SDF_VERSION_FULL}")
set (CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

# Include GNUInstallDirs to get canonical paths
include(GNUInstallDirs)

# Default test type for test all over source
set(TEST_TYPE "UNIT")

# developer's option to cache PKG_CONFIG_PATH and
# LD_LIBRARY_PATH for local installs
if(PKG_CONFIG_PATH)
  set (ENV{PKG_CONFIG_PATH} ${PKG_CONFIG_PATH}:$ENV{PKG_CONFIG_PATH})
endif()
if(LD_LIBRARY_PATH)
  set (ENV{LD_LIBRARY_PATH} ${LD_LIBRARY_PATH}:$ENV{LD_LIBRARY_PATH})
endif()

set (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_INCLUDEDIR}/sdformat-${SDF_VERSION}/sdf") 
set (LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR} CACHE STRING "Installation directory for libraries (relative to CMAKE_INSTALL_PREFIX)") 
set (BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR} CACHE STRING "Installation directory for binaries (relative to CMAKE_INSTALL_PREFIX)") 

set (USE_FULL_RPATH OFF CACHE BOOL "Set to true to enable full rpath")


if (USE_FULL_RPATH)
  # use, i.e. don't skip the full RPATH for the build tree
  set(CMAKE_SKIP_BUILD_RPATH  FALSE)
  
  # when building, don't use the install RPATH already
  # (but later on when installing)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
  
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
  
  # add the automatically determined parts of the RPATH
  # which point to directories outside the build tree to the install RPATH
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  
  # the RPATH to be used when installing, but only if its not a system directory
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" isSystemDir)
  if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
  endif("${isSystemDir}" STREQUAL "-1")
endif()

set (BUILD_SDF ON CACHE INTERNAL "Build SDF" FORCE)
set (build_errors "" CACHE INTERNAL "build errors" FORCE)
set (build_warnings "" CACHE INTERNAL "build warnings" FORCE)

set (sdf_cmake_dir ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
     "Location of CMake scripts")

#####################################
# Build type cflags
set (CMAKE_C_FLAGS_ALL " -Wall -Wextra -Wno-long-long -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wfloat-equal -Wshadow -Winit-self -Wswitch-default -Wmissing-include-dirs -pedantic" CACHE INTERNAL "General C Flags")

#####################################
# Build type link flags
set (CMAKE_LINK_FLAGS_RELEASE " " CACHE INTERNAL "Link flags fro release" FORCE)
set (CMAKE_LINK_FLAGS_DEBUG " " CACHE INTERNAL "Link flags for debug" FORCE)

set (CMAKE_C_FLAGS_RELEASE "")
if (NOT APPLE)
  # -s doesn't work with default osx compiler clang, alternative:
  # http://stackoverflow.com/questions/6085491/gcc-vs-clang-symbol-strippingu
  set (CMAKE_C_FLAGS_RELEASE " -s ")
endif()
set (CMAKE_C_FLAGS_RELEASE " ${CMAKE_C_FLAGS_RELEASE} -O2 -DNDEBUG ${CMAKE_C_FLAGS_ALL}"
  CACHE INTERNAL "C Flags for release" FORCE)
set (CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})

set (CMAKE_C_FLAGS_DEBUG " -ggdb3 ${CMAKE_C_FLAGS_ALL}"
  CACHE INTERNAL "C Flags for debug" FORCE)
set (CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})

#####################################
# Set the default build type
if (NOT CMAKE_BUILD_TYPE)
  set (CMAKE_BUILD_TYPE "RELEASE" CACHE STRING 
    "Choose the type of build, options are: debug release profile check" FORCE)
endif (NOT CMAKE_BUILD_TYPE)
string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)

#####################################
# Set all the global build flags
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE}}")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}")
set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_LINK_FLAGS_${CMAKE_BUILD_TYPE}}")
set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_LINK_FLAGS_${CMAKE_BUILD_TYPE}}")
set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_LINK_FLAGS_${CMAKE_BUILD_TYPE}}")

if ("${CMAKE_BUILD_TYPE}" STREQUAL "RELEASE")
  set (BUILD_TYPE_RELEASE TRUE)
else()
  set (BUILD_TYPE_RELEASE FALSE)
endif()

if ( "${CMAKE_BUILD_TYPE}" STREQUAL "DEBUG")
  set (BUILD_TYPE_DEBUG TRUE)
else()
  set (BUILD_TYPE_DEBUG FALSE)
endif()

message (STATUS "\n\n====== Finding 3rd Party Packages ======")
include (${sdf_cmake_dir}/SearchForStuff.cmake)
message (STATUS "----------------------------------------\n")


#################################################
# OS Specific initialization
if (UNIX)
  sdf_setup_unix()
else (WIN32)
  sdf_setup_windows()
else (APPLE)
  sdf_setup_apple()
endif()

#################################################
# Print warnings and errors
if ( build_warnings )
  message(STATUS "BUILD WARNINGS")
  foreach (msg ${build_warnings})
    message(STATUS ${msg})
  endforeach ()
  message(STATUS "END BUILD WARNINGS\n")
endif (build_warnings)

########### Add uninstall target ###############
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake/cmake_uninstall.cmake")

if (build_errors)
  message(STATUS "BUILD ERRORS: These must be resolved before compiling.")
  foreach (msg ${build_errors})
    message(STATUS ${msg})
  endforeach ()
  message(STATUS "END BUILD ERRORS\n")
  message (FATAL_ERROR "Errors encountered in build. Please see the BUILD ERRORS above.")

else (buid_errors)

  ########################################
  # Write the config.h file
  configure_file (${sdf_cmake_dir}/sdf_config.h.in
    ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)
  sdf_install_includes("" ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)

  message (STATUS "C Flags:${CMAKE_CXX_FLAGS}")
  message (STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
  message (STATUS "Install path: ${CMAKE_INSTALL_PREFIX}")
 
  if (BUILD_SDF)
    include_directories(include
      ${PROJECT_BINARY_DIR}
      ${PROJECT_BINARY_DIR}/include
      )

    add_subdirectory(test)
    add_subdirectory(src)
    add_subdirectory(include/sdf)
    add_subdirectory(sdf)
    add_subdirectory(doc)
  endif(BUILD_SDF)

  ########################################
  # Make the package config file
  configure_file(${CMAKE_SOURCE_DIR}/cmake/sdformat_pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/sdformat.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/cmake/sdformat.pc DESTINATION
    ${LIB_INSTALL_DIR}/pkgconfig COMPONENT pkgconfig)

  ########################################
  # Make the cmake config files
  set(PKG_NAME ${PROJECT_NAME})
  set(PKG_LIBRARIES sdformat)
  set(PKG_DEPENDS Boost)
  set(cmake_conf_file "cmake/sdf_config.cmake")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${cmake_conf_file}.in" "${CMAKE_CURRENT_BINARY_DIR}/SDFormatConfig.cmake" @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SDFormatConfig.cmake DESTINATION ${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME_LOWER}/ COMPONENT cmake)

  ########################################
  # Package Creation: 
  include (${sdf_cmake_dir}/sdf_cpack.cmake)
  set (CPACK_PACKAGE_VERSION "${SDF_VERSION_FULL}")
  set (CPACK_PACKAGE_VERSION_MAJOR "${SDF_MAJOR_VERSION}")
  set (CPACK_PACKAGE_VERSION_MINOR "${SDF_MINOR_VERSION}")
  set (CPACK_PACKAGE_VERSION_PATCH "${SDF_PATCH_VERSION}")

  if (CPACK_GENERATOR)
    message(STATUS "Found CPack generators: ${CPACK_GENERATOR}")

    configure_file("${sdf_cmake_dir}/cpack_options.cmake.in"
                   ${SDF_CPACK_CFG_FILE} @ONLY)
    set(CPACK_PROJECT_CONFIG_FILE ${SDF_CPACK_CFG_FILE})
    include (CPack)
  endif()

  message(STATUS "Configuration successful. Type make to compile sdf")
endif(build_errors)

=== sdf/CMakeLists.txt ===
add_subdirectory(1.0)
add_subdirectory(1.2)
add_subdirectory(1.3)
add_subdirectory(1.4)

=== src/CMakeLists.txt ===
include (${sdf_cmake_dir}/SDFUtils.cmake)

include_directories(${PROJECT_SOURCE_DIR}/src/urdf)

link_directories(
  ${PROJECT_BINARY_DIR}/test
)

set (sources
  Assert.cc
  Console.cc
  Converter.cc
  Exception.cc
  parser.cc
  parser_urdf.cc
  Param.cc
  SDF.cc
  urdf/urdf_parser/model.cpp
  urdf/urdf_parser/link.cpp
  urdf/urdf_parser/joint.cpp
  urdf/urdf_parser/pose.cpp
  urdf/urdf_parser/twist.cpp
  urdf/urdf_parser/urdf_model_state.cpp
  urdf/urdf_parser/urdf_sensor.cpp
  urdf/urdf_parser/world.cpp
)

set (gtest_sources
  SDF_TEST.cc
  Console_TEST.cc
  Converter_TEST.cc
  parser_urdf_TEST.cc
)
sdf_build_tests(${gtest_sources})

sdf_add_library(sdformat ${sources})
target_link_libraries(sdformat
  ${tinyxml_libraries}
  ${Boost_LIBRARIES}
)
sdf_install_library(sdformat)

=== test/CMakeLists.txt ===
include_directories (
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
  ${Boost_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/test/gtest/include
  ${PROJECT_SOURCE_DIR}/test/gtest
  ${PROJECT_SOURCE_DIR}/test
)

link_directories(
  ${Boost_LIBRARY_DIRS}
)

configure_file (test_config.h.in ${PROJECT_BINARY_DIR}/test_config.h)

# Build gtest
add_library(gtest STATIC gtest/src/gtest-all.cc)
add_library(gtest_main STATIC gtest/src/gtest_main.cc)
target_link_libraries(gtest_main gtest)
set(GTEST_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest.a")
set(GTEST_MAIN_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest_main.a")

execute_process(COMMAND cmake -E remove_directory ${CMAKE_BINARY_DIR}/test_results)
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)
include_directories(${GTEST_INCLUDE_DIRS})

add_subdirectory(integration)
add_subdirectory(performance)

=== include/sdf/CMakeLists.txt ===
include (${sdf_cmake_dir}/SDFUtils.cmake)

set (headers
  Assert.hh
  Console.hh
  Converter.hh
  Exception.hh
  Param.hh
  parser.hh
  SDFImpl.hh
  Types.hh
)

set (sdf_headers "" CACHE INTERNAL "SDF headers" FORCE)
foreach (hdr ${headers})
  APPEND_TO_CACHED_STRING(sdf_headers
    "SDF Headers" "#include <sdf/${hdr}>\n")
endforeach()
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/sdf.hh.in
                ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

sdf_install_includes("" ${headers} parser_urdf.hh
  ${CMAKE_CURRENT_BINARY_DIR}/sdf.hh)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  audio.cc
  fixed_joint_reduction.cc
  provide_feedback.cc
  cfm_damping_implicit_spring_damper.cc
)

link_directories(${PROJECT_BINARY_DIR}/test)

sdf_build_tests(${tests})

=== debian/changelog ===
sdformat (1.4.11-1) unstable; urgency=high
 
  * Initial release. (Closes: #728719)
 
 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 7 Nov 2013 04:46:00 -0700

=== debian/control ===
Source: sdformat
Standards-Version: 3.9.5
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: extra
Build-Depends: cmake,
               debhelper (>= 9),
               pkg-kde-tools,
               latex-xcolor,
               libboost-system-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-iostreams-dev,
               libtinyxml-dev,
               liburdfdom-dev,
               doxygen,
               texlive-base,
               texlive-fonts-recommended,
               texlive-latex-extra
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/sdformat.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/sdformat.git
Homepage: http://sdformat.org

Package: libsdformat1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Simulation Description Format (SDF) parser - Shared library
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package gathers the shared library

Package: libsdformat-dev
Architecture: any
Section: libdevel
Depends: libboost-system-dev,
         libboost-filesystem-dev,
         libboost-program-options-dev,
         libboost-regex-dev,
         libtinyxml-dev,
         liburdfdom-dev,
         libsdformat1 (= ${binary:Version}),
         ${misc:Depends}
Multi-Arch: same
Description: Simulation Description Format (SDF) parser - Development files
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains development files (headers, shared library
 symbolic link and cmake file).
 
Package: libsdformat1-dbg
Architecture: any
Section: debug
Depends:
     libsdformat1 (= ${binary:Version}),
     ${misc:Depends}
Multi-Arch: same
Description: Simulation Description Format (SDF) parser - Debugging symbols
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains the debugging symbols.

Package: sdformat-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Multi-Arch: foreign
Description: Simulation Description Format (SDF) parser - Documentation
 SDF is an XML file format that describes environments, objects, and robots
 in a manner suitable for robotic applications. SDF is capable of representing
 and describing different physic engines, lighting properties, terrain, static
 or dynamic objects, and articulated robots with various sensors, and acutators.
 The format of SDF is also described by XML, which facilitates updates and
 allows conversion from previous versions. A parser is also contained within
 this package that reads SDF files and returns a C++ interface.
 .
 This package contains the program documentation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

.PHONY: override_dh_auto_configure \
        override_dh_auto_build-indep \
        override_dh_auto_test \
        override_dh_strip 

%:
	dh $@ --parallel --with pkgkde-symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- \
            -DUSE_EXTERNAL_URDF:BOOL=True \
            -DUSE_UPSTREAM_CFLAGS:BOOL=False

override_dh_auto_build-indep:
	dh_auto_build -- doc # Generate documentation.
 
# Tests are broken without a installed copy of sdformat.
# see: https://bitbucket.org/osrf/sdformat/issue/35 
override_dh_auto_test:
	true
       
override_dh_strip:
	dh_strip -a --dbg-package=libsdformat1-dbg

## sdformat 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,9 +23,13 @@
 project (SDFormat)
 string (TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 
-set (SDF_MAJOR_VERSION 1)
-set (SDF_MINOR_VERSION 4)
-set (SDF_PATCH_VERSION 11)
+# The protocol version has nothing to do with the package version set below.
+# It represents the current version of sdformat implement by the software
+set (SDF_PROTOCOL_VERSION 1.5)
+
+set (SDF_MAJOR_VERSION 2)
+set (SDF_MINOR_VERSION 0)
+set (SDF_PATCH_VERSION 0)
 
 set (SDF_VERSION ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION})
 set (SDF_VERSION_FULL ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION}.${SDF_PATCH_VERSION})
@@ -83,28 +87,42 @@
 set (sdf_cmake_dir ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
      "Location of CMake scripts")
 
+ message (STATUS "\n\n====== Finding 3rd Party Packages ======")
+include (${sdf_cmake_dir}/SearchForStuff.cmake)
+message (STATUS "----------------------------------------\n")
+
 #####################################
 # Build type cflags
 set (CMAKE_C_FLAGS_ALL " -Wall -Wextra -Wno-long-long -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wfloat-equal -Wshadow -Winit-self -Wswitch-default -Wmissing-include-dirs -pedantic" CACHE INTERNAL "General C Flags")
 
+# Check and add visibility hidden by default
+if (UNIX)
+  check_gcc_visibility()
+  if (GCC_SUPPORTS_VISIBILITY)
+         SET(CMAKE_C_FLAGS_ALL "${CMAKE_C_FLAGS_ALL} -fvisibility=hidden")
+  endif()
+endif()
+
 #####################################
 # Build type link flags
-set (CMAKE_LINK_FLAGS_RELEASE " " CACHE INTERNAL "Link flags fro release" FORCE)
-set (CMAKE_LINK_FLAGS_DEBUG " " CACHE INTERNAL "Link flags for debug" FORCE)
-
-set (CMAKE_C_FLAGS_RELEASE "")
-if (NOT APPLE)
-  # -s doesn't work with default osx compiler clang, alternative:
-  # http://stackoverflow.com/questions/6085491/gcc-vs-clang-symbol-strippingu
-  set (CMAKE_C_FLAGS_RELEASE " -s ")
-endif()
-set (CMAKE_C_FLAGS_RELEASE " ${CMAKE_C_FLAGS_RELEASE} -O2 -DNDEBUG ${CMAKE_C_FLAGS_ALL}"
-  CACHE INTERNAL "C Flags for release" FORCE)
-set (CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
-
-set (CMAKE_C_FLAGS_DEBUG " -ggdb3 ${CMAKE_C_FLAGS_ALL}"
-  CACHE INTERNAL "C Flags for debug" FORCE)
-set (CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
+
+# USE_UPSTREAM_CFLAGS (default TRUE)
+# Use our own defined flags for building types
+if(NOT DEFINED USE_UPSTREAM_CFLAGS OR USE_UPSTREAM_CFLAGS)
+  message(STATUS "Using upstream CFlags")
+  if (NOT APPLE)
+    # -s doesn't work with default osx compiler clang, alternative:
+    # http://stackoverflow.com/questions/6085491/gcc-vs-clang-symbol-strippingu
+    set (CMAKE_C_FLAGS_RELEASE " -s ")
+  endif()
+  set (CMAKE_C_FLAGS_RELEASE " ${CMAKE_C_FLAGS_RELEASE} -O2 -DNDEBUG"
+    CACHE INTERNAL "C Flags for release" FORCE)
+  set (CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
+  
+  set (CMAKE_C_FLAGS_DEBUG " -ggdb3"
+    CACHE INTERNAL "C Flags for debug" FORCE)
+  set (CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
+endif()
 
 #####################################
 # Set the default build type
@@ -116,11 +134,8 @@
 
 #####################################
 # Set all the global build flags
-set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE}}")
-set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}")
-set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_LINK_FLAGS_${CMAKE_BUILD_TYPE}}")
-set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_LINK_FLAGS_${CMAKE_BUILD_TYPE}}")
-set (CMAKE_MODULE_LINKER_FLAGS "${CMAKE_LINK_FLAGS_${CMAKE_BUILD_TYPE}}")
+set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE}} ${CMAKE_C_FLAGS_ALL}")
+set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CMAKE_C_FLAGS_ALL}")
 
 if ("${CMAKE_BUILD_TYPE}" STREQUAL "RELEASE")
   set (BUILD_TYPE_RELEASE TRUE)
@@ -133,10 +148,6 @@
 else()
   set (BUILD_TYPE_DEBUG FALSE)
 endif()
-
-message (STATUS "\n\n====== Finding 3rd Party Packages ======")
-include (${sdf_cmake_dir}/SearchForStuff.cmake)
-message (STATUS "----------------------------------------\n")
 
 
 #################################################
@@ -183,7 +194,7 @@
     ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)
   sdf_install_includes("" ${PROJECT_BINARY_DIR}/sdf/sdf_config.h)
 
-  message (STATUS "C Flags:${CMAKE_CXX_FLAGS}")
+  message (STATUS "C Flags:${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}")
   message (STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
   message (STATUS "Install path: ${CMAKE_INSTALL_PREFIX}")

=== sdf/CMakeLists.txt ===
add_subdirectory(1.0)
add_subdirectory(1.2)
add_subdirectory(1.3)
add_subdirectory(1.4)
add_subdirectory(1.5)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,13 @@
 include (${sdf_cmake_dir}/SDFUtils.cmake)
-
-include_directories(${PROJECT_SOURCE_DIR}/src/urdf)
 
 link_directories(
   ${PROJECT_BINARY_DIR}/test
+  ${tinyxml_LIBRARY_DIRS}
 )
+
+if (USE_EXTERNAL_URDF)
+  link_directories(${URDF_LIBRARY_DIRS})
+endif()
 
 set (sources
   Assert.cc
@@ -15,6 +18,13 @@
   parser_urdf.cc
   Param.cc
   SDF.cc
+)
+
+if (USE_EXTERNAL_URDF)
+  include_directories(${URDF_INCLUDE_DIRS})
+else()
+  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/urdf)
+  set(sources ${sources}
   urdf/urdf_parser/model.cpp
   urdf/urdf_parser/link.cpp
   urdf/urdf_parser/joint.cpp
@@ -24,6 +34,7 @@
   urdf/urdf_parser/urdf_sensor.cpp
   urdf/urdf_parser/world.cpp
 )
+endif()
 
 set (gtest_sources
   SDF_TEST.cc
@@ -35,7 +46,15 @@
 
 sdf_add_library(sdformat ${sources})
 target_link_libraries(sdformat
-  ${tinyxml_libraries}
+  ${tinyxml_LIBRARIES}
   ${Boost_LIBRARIES}
 )
+
+message (STATUS "URDF_LIBRARY_DIRS=${URDF_LIBRARY_DIRS}")
+message (STATUS "URDF_LIBRARIES=${URDF_LIBRARIES}")
+
+if (USE_EXTERNAL_URDF)
+  target_link_libraries(sdformat ${URDF_LIBRARIES})
+endif()
+
 sdf_install_library(sdformat)

=== include/sdf/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
   parser.hh
   SDFImpl.hh
   Types.hh
+  system_util.hh
 )
 
 set (sdf_headers "" CACHE INTERNAL "SDF headers" FORCE)

=== sdf/1.0/CMakeLists.txt ===
set (sdfs
  actor.sdf 
  camera.sdf
  collision.sdf 
  contact.sdf
  gazebo.sdf 
  geometry.sdf 
  gripper.sdf
  gui.sdf
  inertial.sdf 
  joint.sdf 
  light.sdf 
  link.sdf 
  model.sdf 
  physics.sdf 
  plugin.sdf 
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  scene.sdf 
  sensor.sdf 
  state.sdf
  surface.sdf 
  visual.sdf 
  world.sdf
)

install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.0/)

=== sdf/1.2/CMakeLists.txt ===
set (sdfs
  1_0.convert
  actor.sdf 
  camera.sdf
  collision.sdf 
  contact.sdf
  gazebo.sdf 
  geometry.sdf 
  gripper.sdf
  gui.sdf
  inertial.sdf 
  joint.sdf 
  light.sdf 
  link.sdf 
  model.sdf 
  physics.sdf 
  plugin.sdf 
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  scene.sdf 
  sensor.sdf 
  state.sdf
  surface.sdf 
  visual.sdf 
  world.sdf
)

install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.2)

=== sdf/1.3/CMakeLists.txt ===
set (sdfs
  1_2.convert
  actor.sdf 
  camera.sdf
  collision.sdf 
  contact.sdf
  geometry.sdf 
  gripper.sdf
  gui.sdf
  imu.sdf
  inertial.sdf 
  joint.sdf 
  light.sdf 
  link.sdf 
  model.sdf 
  physics.sdf 
  plugin.sdf 
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf 
  scene.sdf 
  sensor.sdf 
  state.sdf
  surface.sdf 
  visual.sdf 
  world.sdf
)

install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.3)

=== sdf/1.4/CMakeLists.txt ===
set (sdfs
  1_3.convert
  actor.sdf
  audio_source.sdf
  audio_sink.sdf
  box_shape.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  light.sdf
  link.sdf
  mesh_shape.sdf
  model.sdf
  noise.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.4)

=== sdf/1.5/CMakeLists.txt ===
set (sdfs
  1_4.convert
  actor.sdf
  audio_source.sdf
  audio_sink.sdf
  box_shape.sdf
  camera.sdf
  collision.sdf
  contact.sdf
  cylinder_shape.sdf
  forcetorque.sdf
  geometry.sdf
  gps.sdf
  gripper.sdf
  gui.sdf
  heightmap_shape.sdf
  image_shape.sdf
  imu.sdf
  inertial.sdf
  joint.sdf
  light.sdf
  link.sdf
  mesh_shape.sdf
  model.sdf
  noise.sdf
  physics.sdf
  plane_shape.sdf
  plugin.sdf
  projector.sdf
  ray.sdf
  rfidtag.sdf
  rfid.sdf
  road.sdf
  root.sdf
  scene.sdf
  sensor.sdf
  spherical_coordinates.sdf
  sphere_shape.sdf
  sonar.sdf
  state.sdf
  surface.sdf
  transceiver.sdf
  visual.sdf
  world.sdf
)

install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.5)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  audio.cc
  cfm_damping_implicit_spring_damper.cc
  fixed_joint_reduction.cc
  joint_axis_frame.cc
  provide_feedback.cc
)

link_directories(${PROJECT_BINARY_DIR}/test)

sdf_build_tests(${tests})

=== debian/changelog ===
sdformat (2.0.0-6) unstable; urgency=medium

  [ Dejan Latinovic ]
  * Team upload.
  * Fix FTBFS due to a failing tests. (Closes: #754619)

 -- Anton Gladky <gladk@debian.org>  Tue, 16 Sep 2014 22:08:55 +0200

sdformat (2.0.0-5) unstable; urgency=medium

  * [31b98a5] Define LC_ALL=POSIX for the test suite (Closes: #750133)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sun, 22 Jun 2014 18:14:33 +0000

sdformat (2.0.0-4) unstable; urgency=medium

  * [5a3c8f0] Implement sdformat-sdf to host common files (Closes: #747393)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 16 May 2014 17:30:12 +0000

sdformat (2.0.0-3) unstable; urgency=medium

  * [f03ab47] Conflict with libsdformat1. (Closes: #747393)
  * [2f73b57] Restrict test suite only to amd64 (Closes: #747361)
  * [2b207c6] Support for autopkgtest

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 09 May 2014 19:35:55 +0000

sdformat (2.0.0-2) unstable; urgency=medium

  * Add license for search.js. (Closes: #747314)
  * Fix autotests.

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 07 May 2014 15:12:41 +0000

sdformat (2.0.0-1) unstable; urgency=medium

  * Fix compilation against urdfdom-0.3.0 (Closes: #74381)
  * Fix watch file to check for several digits versions
  * Upstream fixed the problems for running tests
  * Imported Upstream version 2.0.0
  * New ABI sdformat1 -> sdformat2
  * Remove patches, all changes were merged upstream

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sat, 19 Apr 2014 16:37:43 +0000

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
 Section: science
-Priority: extra
+Priority: optional
+Testsuite: autopkgtest
 Build-Depends: cmake,
                debhelper (>= 9),
-               pkg-kde-tools,
+               python,
                latex-xcolor,
                libboost-system-dev,
                libboost-filesystem-dev,
@@ -23,11 +24,13 @@
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/sdformat.git
 Homepage: http://sdformat.org
 
-Package: libsdformat1
+Package: libsdformat2
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:  sdformat-sdf (>= ${source:Version}),
+          ${shlibs:Depends},
+          ${misc:Depends}
 Multi-Arch: same
 Description: Simulation Description Format (SDF) parser - Shared library
  SDF is an XML file format that describes environments, objects, and robots
@@ -49,7 +52,7 @@
          libboost-regex-dev,
          libtinyxml-dev,
          liburdfdom-dev,
-         libsdformat1 (= ${binary:Version}),
+         libsdformat2 (= ${binary:Version}),
          ${misc:Depends}
 Multi-Arch: same
 Description: Simulation Description Format (SDF) parser - Development files
@@ -63,12 +66,31 @@
  .
  This package contains development files (headers, shared library
  symbolic link and cmake file).
+
+Package: sdformat-sdf
+Architecture: all
+Section: libdevel
+Depends: ${misc:Depends}
+Multi-Arch: foreign
+Conflicts: libsdformat1
+Description: Simulation Description Format (SDF) parser - SDF files
+ SDF is an XML file format that describes environments, objects, and robots
+ in a manner suitable for robotic applications. SDF is capable of representing
+ and describing different physic engines, lighting properties, terrain, static
+ or dynamic objects, and articulated robots with various sensors, and acutators.
+ The format of SDF is also described by XML, which facilitates updates and
+ allows conversion from previous versions. A parser is also contained within
+ this package that reads SDF files and returns a C++ interface.
+ .
+ This package contains SDF (Simulation Description Format) XML files needed by
+ the libsdformat.
  
-Package: libsdformat1-dbg
+Package: libsdformat2-dbg
 Architecture: any
 Section: debug
+Priority: extra
 Depends:
-     libsdformat1 (= ${binary:Version}),
+     libsdformat2 (= ${binary:Version}),
      ${misc:Depends}
 Multi-Arch: same
 Description: Simulation Description Format (SDF) parser - Debugging symbols

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
            -DUSE_EXTERNAL_URDF:BOOL=True \
            -DUSE_UPSTREAM_CFLAGS:BOOL=False \
            -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo

override_dh_auto_build-indep:
	dh_auto_build -- doc # Generate documentation.

override_dh_auto_test:
	HOME=$(CURDIR) LC_ALL=POSIX dh_auto_test

override_dh_strip:
	dh_strip -a --dbg-package=libsdformat2-dbg

=== debian/tests/control ===
Tests: build
Depends: libsdformat-dev, build-essential

=== debian/watch ===
version=3
http://gazebosim.org/assets/distributions/sdformat-(\d*\.\d*\.\d*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## sdformat 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
+cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)
 
 if(COMMAND CMAKE_POLICY)
   CMAKE_POLICY(SET CMP0003 NEW)
@@ -28,7 +28,7 @@
 set (SDF_PROTOCOL_VERSION 1.5)
 
 set (SDF_MAJOR_VERSION 2)
-set (SDF_MINOR_VERSION 0)
+set (SDF_MINOR_VERSION 2)
 set (SDF_PATCH_VERSION 0)
 
 set (SDF_VERSION ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION})
@@ -224,8 +224,23 @@
   set(PKG_LIBRARIES sdformat)
   set(PKG_DEPENDS Boost)
   set(cmake_conf_file "cmake/sdf_config.cmake")
+  set(cmake_conf_version_file "cmake/SDFormatConfigVersion.cmake")
   configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${cmake_conf_file}.in" "${CMAKE_CURRENT_BINARY_DIR}/SDFormatConfig.cmake" @ONLY)
-  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/SDFormatConfig.cmake DESTINATION ${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME_LOWER}/ COMPONENT cmake)
+  # Use write_basic_package_version_file to generate a ConfigVersion file that
+  # allow users of gazebo to specify the API or version to depend on
+  # TODO: keep this instruction until deprecate Ubuntu/Precise and update with
+  # https://github.com/Kitware/CMake/blob/v2.8.8/Modules/CMakePackageConfigHelpers.cmake 
+  include(WriteBasicConfigVersionFile)
+  write_basic_config_version_file(
+      ${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_version_file}
+      VERSION "${SDF_VERSION_FULL}"
+      COMPATIBILITY SameMajorVersion)
+  install(FILES 
+            ${CMAKE_CURRENT_BINARY_DIR}/SDFormatConfig.cmake
+            ${CMAKE_CURRENT_BINARY_DIR}/${cmake_conf_version_file}
+          DESTINATION 
+	    ${LIB_INSTALL_DIR}/cmake/${PROJECT_NAME_LOWER}/ 
+	  COMPONENT cmake)
 
   ########################################
   # Package Creation:

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,10 @@
 link_directories(
   ${Boost_LIBRARY_DIRS}
 )
+
+if (USE_EXTERNAL_URDF)
+  link_directories(${URDF_LIBRARY_DIRS})
+endif()
 
 configure_file (test_config.h.in ${PROJECT_BINARY_DIR}/test_config.h)

=== sdf/1.5/CMakeLists.txt ===
--- 
+++ 
@@ -20,12 +20,16 @@
   joint.sdf
   light.sdf
   link.sdf
+  magnetometer.sdf
+  material.sdf
   mesh_shape.sdf
   model.sdf
   noise.sdf
   physics.sdf
   plane_shape.sdf
   plugin.sdf
+  polyline_shape.sdf
+  population.sdf
   projector.sdf
   ray.sdf
   rfidtag.sdf

=== test/integration/CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,11 @@
   audio.cc
   cfm_damping_implicit_spring_damper.cc
   fixed_joint_reduction.cc
+  force_torque_sensor.cc
   joint_axis_frame.cc
+  plugin_attribute.cc
   provide_feedback.cc
+  urdf_joint_parameters.cc
 )
 
 link_directories(${PROJECT_BINARY_DIR}/test)

=== debian/changelog ===
sdformat (2.2.0-1~exp1) experimental; urgency=medium

  * Imported Upstream version 2.2.0
  * Update urdfdom patch with latest work done by upstream
  * Update standards version to 3.9.6
  * Update mailing list

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 21 Nov 2014 01:14:22 +0000

sdformat (2.0.1-1) unstable; urgency=medium

  * Imported Upstream version 2.0.1

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 18 Aug 2014 23:42:06 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: sdformat
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
 Section: science

## sdformat 2.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 set (SDF_PROTOCOL_VERSION 1.5)
 
 set (SDF_MAJOR_VERSION 2)
-set (SDF_MINOR_VERSION 2)
+set (SDF_MINOR_VERSION 3)
 set (SDF_PATCH_VERSION 0)
 
 set (SDF_VERSION ${SDF_MAJOR_VERSION}.${SDF_MINOR_VERSION})
@@ -87,19 +87,60 @@
 set (sdf_cmake_dir ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
      "Location of CMake scripts")
 
- message (STATUS "\n\n====== Finding 3rd Party Packages ======")
+include (${sdf_cmake_dir}/SDFUtils.cmake)
+
+message (STATUS "\n\n====== Finding 3rd Party Packages ======")
+ # Use of tinyxml. System installation on UNIX. Internal copy on WIN
+if (UNIX)
+  message (STATUS "Using system tinyxml")
+  set (USE_EXTERNAL_TINYXML True)
+elseif(WIN32)
+  message (STATUS "Using internal tinyxml code")
+  set (USE_EXTERNAL_TINYXML False)
+else()
+  message (STATUS "Unknown platform")
+  BUILD_ERROR("Unknown platform")
+endif()
 include (${sdf_cmake_dir}/SearchForStuff.cmake)
 message (STATUS "----------------------------------------\n")
 
 #####################################
-# Build type cflags
-set (CMAKE_C_FLAGS_ALL " -Wall -Wextra -Wno-long-long -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wfloat-equal -Wshadow -Winit-self -Wswitch-default -Wmissing-include-dirs -pedantic" CACHE INTERNAL "General C Flags")
+# Check if warning options are avaliable for the compiler and return WARNING_CXX_FLAGS variable
+# MSVC generates tons of warnings on gtest code. 
+# Recommended to use /W4 instead of /Wall
+if (MSVC)
+  set(WARN_LEVEL "/W4")
+else()
+  set(WARN_LEVEL "-Wall")
+endif()
+
+if (WIN32)
+    # Need for M_PI constant
+    add_definitions(-D_USE_MATH_DEFINES) 
+    # Use dynamic linking for boost
+    add_definitions(-DBOOST_ALL_DYN_LINK)
+    # And force linking to MSVC dynamic runtime
+    set(CMAKE_C_FLAGS_DEBUG "/MDd ${CMAKE_C_FLAGS_DEBUG}")
+    set(CMAKE_C_FLAGS_RELEASE "/MD ${CMAKE_C_FLAGS_RELEASE}")
+    if (MSVC AND CMAKE_SIZEOF_VOID_P EQUAL 8)
+      # Not need if proper cmake gnerator (-G "...Win64") is passed to cmake
+      # Enable as a second measeure to workaround over bug
+      # http://www.cmake.org/Bug/print_bug_page.php?bug_id=11240 
+      set(CMAKE_SHARED_LINKER_FLAGS "/machine:x64")
+    endif()
+ENDIF(WIN32)
+
+filter_valid_compiler_warnings(${WARN_LEVEL} -Wextra -Wno-long-long
+  -Wno-unused-value -Wno-unused-value -Wno-unused-value -Wno-unused-value
+  -Wfloat-equal -Wshadow -Winit-self -Wswitch-default
+  -Wmissing-include-dirs -pedantic)
+set (CMAKE_C_FLAGS_ALL "${WARNING_CXX_FLAGS}")
 
 # Check and add visibility hidden by default
 if (UNIX)
   check_gcc_visibility()
   if (GCC_SUPPORTS_VISIBILITY)
-         SET(CMAKE_C_FLAGS_ALL "${CMAKE_C_FLAGS_ALL} -fvisibility=hidden")
+      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
   endif()
 endif()
 
@@ -110,18 +151,20 @@
 # Use our own defined flags for building types
 if(NOT DEFINED USE_UPSTREAM_CFLAGS OR USE_UPSTREAM_CFLAGS)
   message(STATUS "Using upstream CFlags")
-  if (NOT APPLE)
+  if (NOT APPLE AND NOT MSVC)
     # -s doesn't work with default osx compiler clang, alternative:
     # http://stackoverflow.com/questions/6085491/gcc-vs-clang-symbol-strippingu
-    set (CMAKE_C_FLAGS_RELEASE " -s ")
+    set (CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -s ")
   endif()
   set (CMAKE_C_FLAGS_RELEASE " ${CMAKE_C_FLAGS_RELEASE} -O2 -DNDEBUG"
     CACHE INTERNAL "C Flags for release" FORCE)
   set (CMAKE_CXX_FLAGS_RELEASE ${CMAKE_C_FLAGS_RELEASE})
   
-  set (CMAKE_C_FLAGS_DEBUG " -ggdb3"
-    CACHE INTERNAL "C Flags for debug" FORCE)
-  set (CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
+  if (NOT MSVC)
+    set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -ggdb3"
+      CACHE INTERNAL "C Flags for debug" FORCE)
+    set (CMAKE_CXX_FLAGS_DEBUG ${CMAKE_C_FLAGS_DEBUG})
+  endif()
 endif()
 
 #####################################
@@ -203,6 +246,8 @@
       ${PROJECT_BINARY_DIR}
       ${PROJECT_BINARY_DIR}/include
       )
+  
+    link_directories(${PROJECT_BINARY_DIR}/src)
 
     add_subdirectory(test)
     add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,12 @@
 include (${sdf_cmake_dir}/SDFUtils.cmake)
+
+include_directories(
+  ${Boost_INCLUDE_DIR}
+)
 
 link_directories(
   ${PROJECT_BINARY_DIR}/test
-  ${tinyxml_LIBRARY_DIRS}
+  ${Boost_LIBRARY_DIR}
 )
 
 if (USE_EXTERNAL_URDF)
@@ -19,6 +23,21 @@
   Param.cc
   SDF.cc
 )
+
+include_directories(${Boost_INCLUDE_DIRS})
+
+if (USE_EXTERNAL_TINYXML)
+  include_directories(${tinyxml_INCLUDE_DIRS})
+else()
+  set(sources ${sources}
+    win/tinyxml/tinystr.cpp  
+    win/tinyxml/tinyxmlerror.cpp
+    win/tinyxml/tinyxml.cpp
+    win/tinyxml/tinyxmlparser.cpp)
+    
+    install (FILES win/tinyxml/tinyxml.h 
+	    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/sdformat-${SDF_VERSION})
+endif()
 
 if (USE_EXTERNAL_URDF)
   include_directories(${URDF_INCLUDE_DIRS})
@@ -41,14 +60,17 @@
   Console_TEST.cc
   Converter_TEST.cc
   parser_urdf_TEST.cc
+  Param_TEST.cc
 )
 sdf_build_tests(${gtest_sources})
 
 sdf_add_library(sdformat ${sources})
-target_link_libraries(sdformat
-  ${tinyxml_LIBRARIES}
-  ${Boost_LIBRARIES}
-)
+target_link_libraries(sdformat ${Boost_LIBRARIES})
+
+if (USE_EXTERNAL_TINYXML)
+  link_directories(${tinyxml_LIBRARY_DIRS})
+  target_link_libraries(sdformat ${tinyxml_LIBRARIES})
+endif()
 
 message (STATUS "URDF_LIBRARY_DIRS=${URDF_LIBRARY_DIRS}")
 message (STATUS "URDF_LIBRARIES=${URDF_LIBRARIES}")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,10 @@
   link_directories(${URDF_LIBRARY_DIRS})
 endif()
 
+if (USE_EXTERNAL_TINYXML)
+  link_directories(${tinyxml_LIBRARY_DIRS})
+endif()
+
 configure_file (test_config.h.in ${PROJECT_BINARY_DIR}/test_config.h)
 
 # Build gtest

=== sdf/1.5/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
 set (sdfs
-  1_4.convert
   actor.sdf
   audio_source.sdf
   audio_sink.sdf
@@ -48,4 +47,26 @@
   world.sdf
 )
 
-install(FILES ${sdfs} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.5)
+set (SDF_SCHEMA)
+
+foreach(FIL ${sdfs})
+  get_filename_component(ABS_FIL ${FIL} ABSOLUTE)
+  get_filename_component(FIL_WE ${FIL} NAME_WE)
+
+  list(APPEND SDF_SCHEMA "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd")
+
+  add_custom_command(
+    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${FIL_WE}.xsd"
+    COMMAND ${CMAKE_SOURCE_DIR}/tools/xmlschema.rb
+    ARGS -s ${CMAKE_CURRENT_SOURCE_DIR} -i ${ABS_FIL} -o ${CMAKE_CURRENT_BINARY_DIR}
+    DEPENDS ${ABS_FIL}
+    COMMENT "Running xml schema compiler on ${FIL}"
+    VERBATIM)
+endforeach()
+
+add_custom_target(schema ALL DEPENDS ${SDF_SCHEMA})
+
+set_source_files_properties(${SDF_SCHEMA} PROPERTIES GENERATED TRUE)
+  
+install(FILES 1_4.convert ${sdfs} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.5)
+install(FILES ${SDF_SCHEMA} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/sdformat/1.5)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
  audio.cc
  cfm_damping_implicit_spring_damper.cc
  disable_fixed_joint_reduction.cc
  fixed_joint_reduction.cc
  force_torque_sensor.cc
  joint_axis_frame.cc
  plugin_attribute.cc
  plugin_bool.cc
  provide_feedback.cc
  schema_test.cc
  urdf_joint_parameters.cc
)

link_directories(${PROJECT_BINARY_DIR}/test)

sdf_build_tests(${tests})

# Need to run schema target (build .xsd files) before running schema_test
add_dependencies(${TEST_TYPE}_schema_test schema)

=== debian/changelog ===
sdformat (2.3.0-1~exp1) experimental; urgency=medium

  * Added ruby as dependency to generate schemas
  * Added a patch to disable a test that requires network
  * Remove previous patch. Already merged upstream
  * Imported Upstream version 2.3.0
  * Set Standards-Version: 3.9.6. No changes

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 04 Feb 2015 02:45:51 +0100

sdformat (2.2.0-1) unstable; urgency=medium

  * Imported Upstream version 2.2.0
  * Update urdfdom patch with latest work done by upstream
  * Update standards version to 3.9.6
  * Update mailing list

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 21 Nov 2014 01:14:22 +0000

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,8 @@
                doxygen,
                texlive-base,
                texlive-fonts-recommended,
-               texlive-latex-extra
+               texlive-latex-extra,
+               ruby | ruby-interpreter
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/sdformat.git
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/sdformat.git
 Homepage: http://sdformat.org
